ORIGINAL = 0

      processor 6502

VSYNC   =  $00
VBLANK  =  $01
WSYNC   =  $02
NUSIZ0  =  $04
NUSIZ1  =  $05
COLUP0  =  $06
COLUP1  =  $07
COLUBK  =  $09
RESP0   =  $10
GRP0    =  $1B
HMP0    =  $20
HMOVE   =  $2A
INTIM   =  $0284
TIM64T  =  $0296

       ORG $F000

START:
       SEI            ;2
       CLD            ;2
       LDX    #$00    ;2
       TXA            ;2
       TAY            ;2
LF006: DEX            ;2
       TXS            ;2
       PHA            ;3
       BNE    LF006   ;2
       LDA    #$01    ;2
       STA    $82     ;3
LF00F: LDA    #$02    ;2
       STA    VSYNC   ;3
       STA    WSYNC   ;3
       STA    WSYNC   ;3
       STA    WSYNC   ;3
       LDA    #$2B    ;2
       STA    TIM64T  ;4
       LDA    #$00    ;2
       STA    VSYNC   ;3
       INC    $80     ;5
       LDA    $80     ;3
       AND    #$01    ;2
       BNE    LF032   ;2
       DEC    $82     ;5
       BNE    LF032   ;2
       LDA    #$A0    ;2
       STA    $82     ;3
LF032: LDA    #$FF    ;2
       STA    COLUP0  ;3
       STA    COLUP1  ;3
       LDA    #$00    ;2
       STA    NUSIZ0  ;3
       STA    NUSIZ1  ;3
       LDA    #$06    ;2
       STA    COLUBK  ;3
LF042: LDA    INTIM   ;4
       BNE    LF042   ;2
       STA    WSYNC   ;3
       STA    VBLANK  ;3
       LDY    #$64    ;2
LF04D: STA    WSYNC   ;3
       DEY            ;2
       BNE    LF04D   ;2
       LDX    #$00    ;2
       STX    GRP0    ;3
       LDA    $82,X   ;4
       JSR    LFE00   ;6
       LDA    #$FF    ;2
       STA    GRP0    ;3
       LDY    #$5A    ;2
LF061: STA    WSYNC   ;3
       DEY            ;2
       BNE    LF061   ;2
       LDA    #$02    ;2
       STA    WSYNC   ;3
       STA    VBLANK  ;3
       LDX    #$1E    ;2
LF06E: STA    WSYNC   ;3
       DEX            ;2
       BNE    LF06E   ;2
       JMP    LF00F   ;3




  ORG $FE00

  IF ORIGINAL
;37
LFE00:
       SEC            ;2
       STA    WSYNC   ;3
LFE03: SBC    #$0F    ;2
       BCS    LFE03   ;2
       TAY            ;2
       LDA    LFE0F,Y ;4
       NOP            ;2
       NOP            ;2
       STA    HMP0,X  ;4
;used as a pointer to data @ $FF00
LFE0F:
       STA    RESP0,X ;4
       STA    WSYNC   ;3
       STA    HMOVE   ;3
       RTS            ;6
  ORG $FF00
       .byte $60,$50,$40,$30,$20,$10
       .byte $00,$F0,$E0,$D0,$C0,$B0,$A0,$90,$80


  ELSE
;24
LFE00:
        EOR #$FF         ;2 0-159 is now 255-96 
        clc              ;2
        sta WSYNC        ;3 begin line 1 
DivideLoop 
        ADC #15         ;2
        BCC DivideLoop  ;54 max 
        SBC #7          ;2 
        ASL             ;2 
        ASL             ;2 
        ASL             ;2 
        ASL             ;2 -Shift left 4 places 
        sta HMP0,X      ;4     68 
        sta RESP0,X     ;4     72 
;maybe an extra cycle can be found somewhere? 
        sta WSYNC       ;3
        sta HMOVE       ;3
        RTS             ;6
  ENDIF


  ORG $FFFC
       .word START,0
